import { SelectionModel } from "./TextSelectionLayerModel";

/**
 * Selection model for selecting text in read order by setting a start and end point
 * @extends {SelectionModel}
 */
export default class extends SelectionModel {
	constructor(f, textSelectionModel) {
		super(f, "TextStartEndPointModel");
		this._startPoint = null;
		this._endPoint = null;
		this._textSelectionModel = textSelectionModel;
	}

	setStartPoint(point) {
		this._startPoint = point;
		this._emit("changed.startPoint");
	}
	getStartPoint() {
		return this._startPoint;
	}
	setEndPoint(point) {
		this._endPoint = point;
		this._emit("changed.endPoint");
	}
	getEndPoint() {
		return this._endPoint;
	}
	getSelection() {
		return this._textSelectionModel.getSelection(this._startPoint, this._endPoint);
	}
	getContent() {
		return this._textSelectionModel.getContent(this._startPoint, this._endPoint);
	}
	getHighlight() {
		return this.getSelection();
	}
}
