import $ from "jquery";

export default class DefaultXDropFilter {
	constructor(dataprovider, options) {
		this._options = options || {};
		this._input = $("<input>", {
			class: "form-control XDrop-filter",
			placeholder: this._options.filterPlaceholder
		}).on(
			"input",
			function() {
				dataprovider.updateQuery(this._input.val());
			}.bind(this)
		);

		dataprovider.on("query.changed", query => {
			if (this._input.val() !== query) {
				this._input.val(query);
			}
		});
	}
	getElement() {
		return this._input;
	}
	focus() {
		this._input.trigger("focus").trigger("select");
	}
}
