import CompositeDataProvider from "@esko/xdrop/dataproviders/CompositeDataProvider";

export class KeyListener extends CompositeDataProvider {
  constructor(
    dataprovider, keys = [" ", ","], onKey
  ) {
    super(dataprovider);
    this._onKey = onKey;
    this._keys = keys;
  }

  setQuery(query) {
    const lastKey = query.slice(-1);
    if (this._keys.indexOf(lastKey) > -1) {
      const cont = this._onKey(this._generateResultList(), query.slice(0, -1));
      if(cont === false) {
        return
      }
    }
    super.setQuery(query);
  }
}

export default function listenForKeys(dataprovider, keys = [" ", ","], onKey = () => {}) {
    return new KeyListener(dataprovider, keys, onKey);
}
